<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\api\lists;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\animal_info\AnimalInfo;
use app\common\lists\ListsSearchInterface;
use app\common\model\farm\Farm;
use app\common\model\fence_house\FenceHouse;


/**
 * AnimalInfo列表
 * Class AnimalInfoLists
 * @package app\adminapi\listsanimal_info
 */
class AnimalInfoLists extends BaseApiDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/01/10 15:53
     */
    public function setSearch(): array
    {
        return [
            '=' => ['sn', 'fence_house_id'],

        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/01/10 15:53
     */
    public function lists(): array
    {
        $fenceHouseId = $this->request->get('fence_house_id', '');
        $where = [];
        if (empty($fenceHouseId)) {
            $farmIds = Farm::where('user_id', $this->userId)->column('id');
            $fenceHouseIds = FenceHouse::whereIn('farm_id', $farmIds)->column('id');
            $where[] = ['fence_house_id', 'in', $fenceHouseIds];
        }
        return AnimalInfo::where($this->searchWhere)->where($where)
            ->with(['fenceHouseAttr'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/01/10 15:53
     */
    public function count(): int
    {
        return AnimalInfo::where($this->searchWhere)->count();
    }

}